﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using System.Collections.ObjectModel;
using System.Xml.Serialization;
using System.IO;
using System.ComponentModel;

namespace SaveLoadViewsSample
{
    public partial class MainPage : UserControl
    {
        SavedPivotGridView XMLSerializedView;

        public MainPage()
        {
            InitializeComponent();
        }

        private void SerializeToXml(object sender, RoutedEventArgs e)
        {
            SaveQuery();
        }

        private void DeserializeFromXml(object sender, RoutedEventArgs e)
        {
            LoadQuery();
        }

        void DataSource_PropertyChanged(object sender, PropertyChangedEventArgs e)
        {
            isBusyIndicator.Visibility = e.PropertyName == "Processing" && 
                pivotGrid.DataSource.IsBusy ? Visibility.Visible : Visibility.Collapsed;
        }


        public void SaveQuery()
        {
            XMLSerializedView = new SavedPivotGridView();
            XMLSerializedView.SaveView(pivotGrid);

            XmlSerializer serializer = new XmlSerializer(typeof(SavedPivotGridView));
            MemoryStream memoryStream = new MemoryStream();
            serializer.Serialize(memoryStream, XMLSerializedView);

            SaveFileDialog saveFileDialog = new SaveFileDialog()
            {
                DefaultExt = "xml",
                Filter = "XML files (*.xml)|*.xml|All files (*.*)|*.*",
                FilterIndex = 1
            };

            if (saveFileDialog.ShowDialog() == true)
            {
                using (Stream stream = saveFileDialog.OpenFile())
                {
                    byte[] bytes = memoryStream.ToArray();
                    stream.Write(bytes, 0, bytes.Length);
                    stream.Close();
                    memoryStream.Close();
                }
            }
        }

        public void LoadQuery()
        {

            XmlSerializer serializer = new XmlSerializer(typeof(SavedPivotGridView));

            OpenFileDialog openFileDialog = new OpenFileDialog()
            {
                Multiselect = false,
                Filter = "XML files (*.xml)|*.xml|All files (*.*)|*.*",
                FilterIndex = 1
            };

            bool? result = openFileDialog.ShowDialog();

            if (result != null && result == true)
            {
                XMLSerializedView = (SavedPivotGridView)serializer.Deserialize(openFileDialog.File.OpenRead());
                XMLSerializedView.Fill(pivotGrid);
            }
        }
    }
}
